package com.javacodegeeks.helloworld.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.MouseDownHandler;
import com.google.gwt.event.dom.client.MouseMoveHandler;
import com.google.gwt.event.dom.client.MouseOutHandler;
import com.google.gwt.event.dom.client.MouseOverHandler;
import com.google.gwt.event.dom.client.MouseUpHandler;
import com.google.gwt.event.dom.client.MouseWheelHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeHtmlUtils;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.DialogBox.Caption;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HTMLPanel;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasHorizontalAlignment.HorizontalAlignmentConstant;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.PasswordTextBox;
import com.google.gwt.user.client.ui.PopupPanel;
import com.google.gwt.user.client.ui.RootLayoutPanel;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.UIObject;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class SampleWebApplication implements EntryPoint{

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad() {

		Button btn= new Button("Dialogbox", new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {
				DialogBox dlg = new CustomDialog();
				dlg.center();
			}
		});
		RootPanel.get().add(btn);
	}
	/**
	 * CustomDialog adds DockPanel as its child widget.
	 */
	class CustomDialog extends DialogBox implements ClickHandler {
		public CustomDialog() {
			super(true);
			setText("Sample DialogBox");

			Button closeButton = new Button("Close", this);
			HTML msg = new HTML("A Custom dialog box.",true);

			DockPanel dock = new DockPanel();
			dock.setSpacing(6);
			Image image = new Image();
			image.setUrl("https://www.javacodegeeks.com/wp-content/uploads/2012/12/JavaCodeGeeks-logo.png");
			dock.add(image, DockPanel.CENTER);
			dock.add(closeButton, DockPanel.SOUTH);
			dock.add(msg, DockPanel.NORTH);

			dock.setCellHorizontalAlignment(closeButton, DockPanel.ALIGN_CENTER);
			dock.setWidth("100%");
			setWidget(dock);
		}

		@Override
		public void onClick(ClickEvent event) {
			hide();
		}
	}

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad_Example1() {

		VerticalPanel verticalPanel = new VerticalPanel();
		verticalPanel.setSpacing(10);
		verticalPanel.setBorderWidth(1);
		verticalPanel.setSize("100%", "100%");
		verticalPanel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		verticalPanel.setVerticalAlignment(HasVerticalAlignment.ALIGN_MIDDLE);
		// The log in button
		Button submit = new Button("DialogBox");
		verticalPanel.add(submit);
		submit.addClickHandler(new ClickHandler() {
			@Override
			public void onClick(ClickEvent event) {
				// Add validation
				showCustomDialog();
			}
		});

		// Add our panel to the page
		RootLayoutPanel.get().add(verticalPanel);
	}
	/**
	 * Draws Custom Dialog box. 
	 * @return DialogBox
	 */
	private DialogBox showCustomDialog() {

		final DialogBox dialog = new DialogBox(true, true);
		// Set caption
		dialog.setText("DialogBox Caption");
		dialog.setAnimationEnabled(true);
		dialog.setPopupPosition(100, 150);
		// Set content
		Label content = new Label("This is sample text message inside "
				+ "Customized Dialogbox. In this example a Label is "
				+ "added inside the Dialogbox, whereas any custom widget "
				+ "can be added inside Dialogbox as per application'ser's need. ");
		if (dialog.isAutoHideEnabled())  {
			dialog.setWidget(content);
		} else {
			VerticalPanel vPanel = new VerticalPanel();
			vPanel.setSpacing(10);
			vPanel.add(content);

			vPanel.add(new Button("Close", new ClickHandler() {
				public void onClick(ClickEvent event) {
					dialog.hide();
				}
			}));
			dialog.setWidget(vPanel);
		}
		dialog.show();
		return dialog;
	}
}
